/* 
   - The contents of this file are subject to the Mozilla Public
   - License Version 1.1 (the "License"); you may not use this file
   - except in compliance with the License. You may obtain a copy of
   - the License at http://www.mozilla.org/MPL/
   -
   - Software distributed under the License is distributed on an "AS
   - IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
   - implied. See the License for the specific language governing
   - rights and limitations under the License.
   -
   - The Original Code is this file as it was released on
   - March 20, 2001.
   -
   - The Initial Developer of the Original Code is Henk-Johan van Rantwijk.
   - Portions created by Henk-Johan van Rantwijk are Copyright (C) 2001
   - Henk-Johan van Rantwijk.  All Rights Reserved.
   -
   - Contributor(s):
   -  Henk-Johan van Rantwijk <bugs4hj@netscape.net> (Original Author)
   -  David Perry <d.perry@utoronto.ca>
   -
   - Alternatively, the contents of this file may be used under the
   - terms of the GNU General Public License Version 2 or later (the
   - "GPL"), in which case the provisions of the GPL are applicable
   - instead of those above.  If you wish to allow use of your
   - version of this file only under the terms of the GPL and not to
   - allow others to use your version of this file under the MPL,
   - indicate your decision by deleting the provisions above and
   - replace them with the notice and other provisions required by
   - the GPL.  If you do not delete the provisions above, a recipient
   - may use your version of this file under either the MPL or the
   - GPL.
   -
*/

////////////////////////////////////////////////////////////////////////////////
function openTabListDialog()
{
  window.openDialog("chrome://multiviews/content/multiviewsTabList.xul", "multiviewsTabList",
                     "chrome, dependent, modal, dialog, resizable", getBrowser());
}
////////////////////////////////////////////////////////////////////////////////
function hideTab(aTab)
{
  var clsTab = "close";
  if (aTab.hasAttribute(clsTab))
    aTab.removeAttribute(clsTab);
  else aTab.setAttribute(clsTab, "true");
}
////////////////////////////////////////////////////////////////////////////////
function loadFirstTabPage(aTab)
{
  if (aTab == null)
   aTab = gBrowser.selectedTab;
  var mURI = aTab.getAttribute("firstPage");
  var aBrowser = gBrowser.getBrowserForTab(aTab);
  if (mURI != gBrowser.currentURI.spec && aBrowser)
    aBrowser.loadURI(mURI);
}
////////////////////////////////////////////////////////////////////////////////
function closeAllTabsDialog()
{
  window.openDialog("chrome://multiviews/content/multiviewsClose.xul", "multiviewsClose",
                    "chrome,dependent,modal,dialog,resizable", getBrowser());
}
////////////////////////////////////////////////////////////////////////////////
function FillSelectedHistoryMenu(aParent, aMenu)
{
  deleteHistoryItems(aParent);
  var sessionHistory = getWebNavigation().sessionHistory;
  var count = sessionHistory.count;
  var index = sessionHistory.index;
  var end;
  var j;
  var entry;

  switch (aMenu)
    {
      case "go":
        aParent.lastChild.hidden = (count == 0);
        end = count > MAX_HISTORY_MENU_ITEMS ? count - MAX_HISTORY_MENU_ITEMS : 0;
        for (j = count - 1; j >= end; j--) {
          entry = sessionHistory.getEntryAtIndex(j, false);
          if (entry)
            createRadioMenuItem(aParent, j, entry.title, j==index);
        }
      break;
      case "tab":
        aParent.lastChild.hidden = (count > 0);
        end = count > MAX_HISTORY_MENU_ITEMS ? count - MAX_HISTORY_MENU_ITEMS : 0;
        for (j = count - 1; j >= end; j--) {
          entry = sessionHistory.getEntryAtIndex(j, false);
          if (entry)
            createRadioMenuItem(aParent, j, entry.title, j==index);
        }
      break;
    }
}
////////////////////////////////////////////////////////////////////////////////
function updateGoMenuPopup(aPopupMenu)
{
  var tabs = getBrowser().mPanelContainer.childNodes.length;
  var disabled = tabs == 1;
  var menuItems = aPopupMenu.getElementsByAttribute("tbattr", "tabbrowser-multiple");
  for (var i = 0; i < menuItems.length; i++)
    menuItems[i].setAttribute("disabled", disabled);
}
////////////////////////////////////////////////////////////////////////////////
function storeGroupData()
{
  var browser = getBrowser().mPanelContainer.childNodes;
  var tab = getBrowser().mTabContainer.childNodes;
  removeGroupData();

  for (var index = 0; index < browser.length; index++) {
    var url = browser[index].webNavigation.currentURI.spec;
    var customLabel = tab[index].getAttribute("customLabel") ? 
                  tab[index].getAttribute("label") : "false";
    addToGroupData(url, customLabel);
  }
  writePref("bool", "multizilla.tabs.startgroup", true);
}
////////////////////////////////////////////////////////////////////////////////
function removeGroupData()
{
  removeData("nc:group-url");
  removeData("nc:group-label");
  writePref("bool", "multizilla.tabs.startgroup", false);
  return true;
}
////////////////////////////////////////////////////////////////////////////////
function removeData(resource)
{
  var RDFC = Components.classes["@mozilla.org/rdf/container-utils;1"].getService(Components.interfaces.nsIRDFContainerUtils);
  var entries = RDFC.MakeSeq(gdLocalStore, RDF.GetResource(resource));

  if (!entries)
    return false;
  if (!entries.GetElements())
    return false;
  var index=entries.GetCount();
  for (index; index > 0; index--) {
    entries.RemoveElementAt(index, true);
  }
  return true;
}
////////////////////////////////////////////////////////////////////////////////
function addToGroupData(url, customLabel)
{
  addData("nc:group-url", url);
  addData("nc:group-label", customLabel);
}
////////////////////////////////////////////////////////////////////////////////
function addData(recource, item)
{
  var RDFC = Components.classes["@mozilla.org/rdf/container-utils;1"].getService(Components.interfaces.nsIRDFContainerUtils);
  var entries = RDFC.MakeSeq(gdLocalStore, RDF.GetResource(recource));
  if (!entries)
    return false;
  if (!entries.GetElements())
    return false;
  // entries.InsertElementAt(RDF.GetLiteral(item), 1, true);
  entries.AppendElement(RDF.GetLiteral(item), true);
  return true;
}
////////////////////////////////////////////////////////////////////////////////
function closeTabOrWindow() 
{
  var tabs = getBrowser().mTabContainer.childNodes.length;
  if (!getBrowser().mTabbedMode && confirmCloseWS(1))
    BrowserCloseWindow(); 
  else if (tabs == 1 && getBrowser().mCurrentBrowser.currentURI.spec == "about:blank" && 
           confirmCloseWS(1))
    BrowserCloseWindow(); 
  else gBrowser.removeCurrentTab();
}
////////////////////////////////////////////////////////////////////////////////
function gotoHistoryPage(aEvent)
{
  var index = aEvent.getAttribute('index');
  getWebNavigation().gotoIndex(index);
}
////////////////////////////////////////////////////////////////////////////////
function getRDFlistItemsFor(aResource, aParent)
{
  deleteHistoryItems(aParent);
  var index = 0;
  var RDFC = Components.classes["@mozilla.org/rdf/container-utils;1"].getService(Components.interfaces.nsIRDFContainerUtils);
  var localstoreData = RDFC.MakeSeq(gdLocalStore, RDF.GetResource(aResource)).GetElements();

  if (!localstoreData.hasMoreElements())
    return(index);

  while (localstoreData.hasMoreElements()) {
    var rdfData = localstoreData.getNext();
    if (rdfData) {
      try {
        rdfData = rdfData.QueryInterface(Components.interfaces.nsIRDFLiteral);
        index++;
      } catch(ex) {
        continue;
      }
     createMenuItem(aParent, index, rdfData.Value);
    }
  }
  return(index);
}
////////////////////////////////////////////////////////////////////////////////
function duplicateTab(aTab, aWinFlag)
{
  var browser = gBrowser.getBrowserForTab(aTab);
  var aURL = browser.currentURI.spec;
  if (aURL && aURL != "about:blank") {
    if (aWinFlag)
      window.open(aURL); 
    else
      gBrowser.selectedTab = gBrowser.addTab(aURL, null);
  }
}
////////////////////////////////////////////////////////////////////////////////
function preventDupeTab(href)
{
  if (readMyPref("multizilla.prevent.double", "bool", true) && href.substring(0,10) != "javascript") {
    gBrowser = getBrowser();
    var tabHref = null;
    var baseHref = href.replace(/#.*/, "");
    if (baseHref[baseHref.length-1] == '/')
      baseHref = baseHref.substring(0, baseHref.length-1);
    for (var i = 0; i < gBrowser.mTabContainer.childNodes.length; i++) {
      if (gBrowser.mTabContainer.childNodes[i].hasAttribute("busy"))
        tabHref = gBrowser.mTabContainer.childNodes[i].getAttribute("firstPage");
      else 
        tabHref = gBrowser.mPanelContainer.childNodes[i].webNavigation.currentURI.spec;
      tabHref = tabHref.replace(/#.*/, "");
      if (tabHref[tabHref.length-1] == '/')
        tabHref = tabHref.substring(0, tabHref.length-1);
      var tab = gBrowser.mTabContainer.childNodes[i];
      if (baseHref == tabHref) {
        if (gBrowser.selectedTab == tab)
          loadURI(href);
        else {
          gBrowser.selectedTab = tab;
          if (href.indexOf("#") != -1)
            loadURI(href); // anchor link like webpage.html#anchor
        }
        return tab;
      }
    }
  }
  return null;
}
////////////////////////////////////////////////////////////////////////////////
function checkForBlankTab()
{
  if (readMyPref("multizilla.tabs.blank-tab-first", "bool", true)) {
    var page = "about:blank";
    var browser = getBrowser();
    var tabs = browser.mPanelContainer.childNodes.length
    for (var i = 0; i < tabs; i++) {
      if (browser.mTabContainer.childNodes[i].hasAttribute("busy"))
        page = browser.mTabContainer.childNodes[i].getAttribute("firstpage");
      else page = browser.mPanelContainer.childNodes[i].currentURI.spec
      if (page == "about:blank")
        return browser.mPanelContainer.childNodes[i];
    }
  }
  return null;
}
////////////////////////////////////////////////////////////////////////////////
function openNewTabOrNewWindow()
{
  if (readMyPref("multizilla.newtabfor.ctrl-n", "bool", true)) {
    var aTab = gBrowser.selectedTab = gBrowser.addPreferredTab();
    if (readMyPref("browser.tabs.loadInBackground", "bool", true))
      getBrowser().selectedTab = aTab;
  }
  else OpenBrowserWindow();
  setTimeout("gURLBar.focus();", 0); 
}
////////////////////////////////////////////////////////////////////////////////
function initMoveTabMenu(aID) 
{
  var windowManager = Components.classes["@mozilla.org/rdf/datasource;1?name=window-mediator"]
                                .getService(nsIWindowDataSource);
  /* var windowManager = Components.classes["@mozilla.org/appshell/window-mediator;1"]
                                .getService(nsIWindowDataSource); */

  var item = document.getElementById(aID);
  while ((item = item.nextSibling)) {
    var url = item.getAttribute('id');
    var win = windowManager.getWindowForResource(url);
    if (win && win == window) {
      item.setAttribute("checked", "true");
      item.setAttribute("disabled", "true");
    }
    else if (!win.getBrowser)
      item.setAttribute("disabled", "true");
  }
}
////////////////////////////////////////////////////////////////////////////////
function moveTabToWindow(aTab, aWindowID)
{
  var windowManager = Components.classes["@mozilla.org/rdf/datasource;1?name=window-mediator"]
                                .getService(nsIWindowDataSource);
  /* var windowManager = Components.classes["@mozilla.org/appshell/window-mediator;1"]
                                .getService(nsIWindowDataSource); */

  var win = windowManager.getWindowForResource(aWindowID);
  if (win && win.gBrowser) {
    var loadInBackground = pref.getBoolPref("browser.tabs.loadInBackground");
    var aURL = gBrowser.getBrowserForTab(aTab).currentURI.spec;
    if (aURL) {
      var newTab = win.gBrowser.addTab(aURL, null);
      if (!loadInBackground)
        win.gBrowser.selectedTab = newTab;
      gBrowser.removeTab(aTab);
    }
  }
}
////////////////////////////////////////////////////////////////////////////////
function moveTabToNewWindow(aTab)
{
  var aBrowser = gBrowser.getBrowserForTab(aTab);
  var aURL = aBrowser.currentURI.spec;
  if (aURL && aURL != "about:blank")
    window.open(aURL);
  gBrowser.removeTab(aTab);
}
////////////////////////////////////////////////////////////////////////////////
function doFKey(aFunctionKey)
{
  aFunctionKey--;
  if (aFunctionKey > -1 && aFunctionKey < gBrowser.mTabList.length)
    gBrowser.selectedTab = gBrowser.mTabList[aFunctionKey];
}
//////////////////////////////////////////////////////////////////////////
function addNewTabFromClipboard()
{
  var aURL = getLocationFromClipboard();
  if (aURL)
    gBrowser.selectedTab = gBrowser.addTab(aURL);
}